Subject: bug#62413: 29.0.60; [PATCH] save-place-mode cannot restore saved position

From: Liu Hui <[email-masked]>
Date: Thu, 30 Mar 2023 10:49:39 +0800

Eli Zaretskii <[email-masked]> 于2023年3月28日周二 20:03写道：
>
> > From: Liu Hui <[email-masked]>
> > Date: Tue, 28 Mar 2023 13:56:05 +0800
> > Cc: [email-masked]
> >
> > Eli Zaretskii <[email-masked]> 于2023年3月26日周日 13:20写道：
> >
> > > Ugh!  This feature was not thought out well enough when it was
> > > introduced: if the user changes the value half-way through a session,
> > > the history will record visited files twice, under 2 different
> > > file-name formats and with different places recorded.  I think
> > > changing the value of save-place-abbreviate-file-names should rewrite
> > > the entire alist in the selected format.
> >
> > I agree that it is better to avoid mixed file name formats, and then
> > save-place-find-file-hook can be fixed simply. The difficult part is
> > how to rewrite save-place-alist automatically.
>
> Isn't it just a matter of going through the list and calling
> abbreviate-file-name on each file name there?

The conversion itself is easy. But users can change the value of
save-place-abbreviate-file-names anytime. To make sure the list is
always consistent with save-place-abbreviate-file-names, I think an
internal variable is needed to record the old value. If they are
different when save-place-to-alist is called, we rewrite the list. Is
it OK?